/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2011 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.integration.ejb;

import java.util.logging.Level;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

/*
 * implementation class for: IPMListener
 *
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
				@ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.Queue"
		) })
public class IPMQListener extends JMSIntegrationListenerHelper implements MessageListener {

	/**
     * Default constructor. 
     */
    public IPMQListener() {    	
    	if ( logger.isLoggable(Level.INFO)) log("\n\n\n~~~~~ IPMQListener initialized.");
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message message) {
    	
    	try {	        
	        if(message instanceof MapMessage) {
	        	if ( logger.isLoggable(Level.INFO)) log("----- onMessage:Q: MapMessage");
	        	processMessage((MapMessage)message);
	        } else {
	        	log("----- onMessage:Q: unrecongnized Message");
	        }
	    } catch(Exception e) {	    	
	    	logError( "Error", "FATAL", e.getMessage());
	    }        
    }
}
