/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2011 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.integration.ejb;

import java.util.logging.Logger;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Message;
import javax.jms.MessageListener;

/**
 * Message-Driven Bean implementation class for: IPMIntgrationTestListener
 *
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
				@ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.Queue"
		) })
public class IPMIntgrationResponseListener implements MessageListener {

	protected Logger logger = Logger.getLogger(this.getClass().getName());
	
    /**
     * Default constructor. 
     */
    public IPMIntgrationResponseListener() {
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message message) {
    	// just log the message    	 
    	logger.info("\n-------------------------\n-------------------------\n" +
    			"onMessage:: got response Message:\n" + message + 
    			"\n-------------------------\n-------------------------\n");
    }

}
