/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.incidentproblemanagement.cbs.service;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.logging.Logger;

import commonj.sdo.DataObject;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.telecom.reference.incidentproblemanagement.cbs.util.IConstants;
import com.ibm.websphere.sca.ServiceManager;

public class CreateCustomerProblemTicketImpl {
	
	private Logger logger = Logger.getLogger(this.getClass().getName()); 
	
	/**
	 * Default constructor.
	 */
	public CreateCustomerProblemTicketImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation "createCustomerProblem" defined for WSDL port type 
	 * named "CreateCustomerProblemPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject createCustomerProblem(DataObject aCustomerProblemMessage) {
		
		logger.info(this.getClass().getName() + " - Enter createCustomerProblem"); 
		
		DataObject customerProblemResponseMessage = IndustrySupportUtil.createDO(IConstants.NS_CUSTOMER_PROBLEM_MESSAGE, IConstants.DO_CUSTOMER_PROBLEM_MESSAGE); 

		DataObject header = (DataObject) aCustomerProblemMessage.getDataObject(IConstants.DO_HEADER_ELEMENT); 
		if (header == null) { 
		   header = IndustrySupportUtil.createDO(IConstants.NS_HEADER, IConstants.DO_HEADER); 
		}
		header.setString(IConstants.MSGTYPE, IConstants.RESPONSE);
		customerProblemResponseMessage.setDataObject(IConstants.DO_HEADER_ELEMENT, header); 

		DataObject customerProblemResponse = IndustrySupportUtil.createDO(IConstants.NS_CUSTOMER_PROBLEM, IConstants.DO_CUSTOMER_PROBLEM);

		SimpleDateFormat dateFormat = new SimpleDateFormat(IConstants.DATE_FORMAT);  
		customerProblemResponse.setString(IConstants.ATTR_CUSTOMER_PROBLEM_ID, IConstants.CUSTOMER_PROBLEM_ID_PREFIX + dateFormat.format(Calendar.getInstance().getTime())); 
		customerProblemResponseMessage.setDataObject(IConstants.DO_CUSTOMER_PROBLEM_ELEMENT, customerProblemResponse); 
		
		logger.info("Customer Problem ID: " + customerProblemResponse.getString(IConstants.ATTR_CUSTOMER_PROBLEM_ID)); 
		
		logger.info(this.getClass().getName() + " - Exit createCustomerProblem"); 
		return customerProblemResponseMessage;
	}

}