/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.incidentproblemanagement.cbs.service;

import java.util.logging.Logger;

import commonj.sdo.DataObject;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.telecom.reference.incidentproblemanagement.cbs.util.IConstants;
import com.ibm.websphere.sca.ServiceManager;

public class LinkToExistingTicketImpl {
	
	private Logger logger = Logger.getLogger(this.getClass().getName()); 
	
	/**
	 * Default constructor.
	 */
	public LinkToExistingTicketImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation "linkTroubleTicket" defined for WSDL port type 
	 * named "LinkTroubleTicketPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that it is a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject linkTroubleTicket(DataObject aTroubleTicketCollectionMessage) {
		
		logger.info(this.getClass().getName() + " - Enter linkTroubleTicket"); 

		DataObject troubleTicketRequest = (DataObject) (aTroubleTicketCollectionMessage.getList(IConstants.DO_TROUBLE_TICKET_ELEMENT)).get(0);  

		DataObject troubleTicketResponseMessage = IndustrySupportUtil.createDO(IConstants.NS_TROUBLE_TICKET_MESSAGE, IConstants.DO_TROUBLE_TICKET_MESSAGE);  

		DataObject header = (DataObject) aTroubleTicketCollectionMessage.getDataObject(IConstants.DO_HEADER_ELEMENT); 
		if (header == null) { 
	       header = IndustrySupportUtil.createDO(IConstants.NS_HEADER, IConstants.DO_HEADER); 
		}
		header.setString(IConstants.MSGTYPE, IConstants.RESPONSE);
		troubleTicketResponseMessage.setDataObject(IConstants.DO_HEADER_ELEMENT, header); 

		DataObject troubleTicketResponse = IndustrySupportUtil.createDO(IConstants.NS_TROUBLE_TICKET, IConstants.DO_TROUBLE_TICKET); 
		troubleTicketResponse.setString(IConstants.ATTR_TROUBLE_TICKET_ID, IConstants.DUMMY_TROUBLE_TICKET_ID);  
		troubleTicketResponseMessage.setDataObject(IConstants.DO_TROUBLE_TICKET_ELEMENT, troubleTicketResponse); 
		
		logger.info("Trouble Ticket ID: " + troubleTicketResponse.getString(IConstants.ATTR_TROUBLE_TICKET_ID)); 
		
		logger.info(this.getClass().getName() + " - Exit linkTroubleTicket"); 
		return troubleTicketResponseMessage;
	}
}