/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.incidentproblemanagement.cbs.util;

public interface IConstants {

	public final String NS_HEADER = "http://www.ibm.com/telecom/common/schema/mtosi/v3_0"; 
	public final String DO_HEADER = "Header_T";
	public final String DO_HEADER_ELEMENT = "header"; 
	
	public final String MSGTYPE = "msgType";
	public final String RESPONSE = "RESPONSE";
	
	public final String NS_TROUBLE_TICKET_COLL_MESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/assurance/schema/TroubleTicketMessage"; 
	public final String DO_TROUBLE_TICKET_COLL_MESSAGE = "TroubleTicketCollectionMessage"; 
	
	public final String NS_TROUBLE_TICKET_MESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/assurance/schema/TroubleTicketMessage"; 
	public final String DO_TROUBLE_TICKET_MESSAGE = "TroubleTicketMessage"; 
	
	public final String NS_TROUBLE_TICKET = "http://www.ibm.com/telecom/assurance/schema/trouble_ticket/v3_0"; 
	public final String DO_TROUBLE_TICKET = "TroubleTicket"; 
	
	
	public final String NS_CUSTOMER_PROBLEM_MESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/assurance/schema/IncidentMessage"; 
	public final String DO_CUSTOMER_PROBLEM_MESSAGE = "CustomerProblemMessage"; 

	public final String NS_CUSTOMER_PROBLEM = "http://www.ibm.com/telecom/assurance/schema/incident/v3_0"; 
	public final String DO_CUSTOMER_PROBLEM = "CustomerProblem"; 
	
	
	public final String NS_RESOURCE_ORDER_MESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/assurance/schema/ResourceOrderMessage"; 
	public final String DO_RESOURCE_ORDER_MESSAGE = "ResourceOrderMessage"; 
	
	public final String NS_RESOURCE_ORDER = "http://www.ibm.com/telecom/fulfillment/schema/resource_order/v3_0"; 
	public final String DO_RESOURCE_ORDER = "ResourceOrder"; 
	
	
	public final String NS_CUSTOMER_PRODCUT_CONFIG_MESSAGE = "http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/inventory/schema/CustomerConfigurationMessage"; 
	public final String DO_CUSTOMER_PRODCUT_CONFIG_MESSAGE = "CustomerConfigurationMessage"; 
	
	public final String NS_CUSTOMER_PRODCUT_CONFIG = "http://www.ibm.com/telecom/inventory/schema/customer_configuration/v3_0"; 
	public final String DO_CUSTOMER_PRODCUT_CONFIG = "CustomerConfiguration"; 
	
	
	public final String DATE_FORMAT = "yyyyMMddHHmmSSSSS"; 
	public final String CUSTOMER_PROBLEM_ID_PREFIX = "CUSTPRB"; 
	public final String TROUBLE_TICKET_ID_PREFIX = "NWTROUBLE"; 
	
	
	// Get Customer Old ProblemTicket, Reopen CustomerProblem & Create CustomerProblem Related
	//
	public final String DO_CUSTOMER_PROBLEM_ELEMENT = "customerProblem"; 

	public final String ATTR_CUSTOMER_PROBLEM_ID = "Id";
	public final String ATTR_CUSTOMER_NAME = "CharacteristicValue[1]/Value[1]";
	public final String ATTR_TROUBLE_TYPE  = "ResourceTroubleTicketItem[1]/Resource/Specification/Type";	
	
	public final String OLD_CUSTOMER_PROBLEM_PROPERTIES_FILE = "/OldCustomerProblemID.properties"; 
	public final String OLD_CUSTOMER_PROBLEM_NOT_FOUND = "CUSTOMER_PROBLEM_ID_NOT_FOUND"; 

	
	// Link TroubleTicket to existing TroubleTicket, Create TroubleTicket & Modify TroubleTicket Related
	//
	public final String ATTR_TROUBLE_TICKET_ID  = "Id"; 
	public final String DUMMY_TROUBLE_TICKET_ID = "NWTROUBLE20090101000000000"; 

	public final String DO_TROUBLE_TICKET_ELEMENT = "trouble_ticket";

	
	// Execute Resource Diagnostic Test Related
	//
	public final String DO_RESOURCE_ORDER_ELEMENT = "resourceOrder"; 
	
	public final String ATTR_EXECUTE_RESOURCE_TEST_QUERY = "ResourceOrderItem[1]/Resource/CharacteristicValue[1]/Value[1]"; 
	public final String ATTR_EXECUTE_RESOURCE_TEST_STATUS = "ResourceOrderItem[1]/Resource/Status";
	
	public final String INVALID_INCIDENT = "INVALID_INCIDENT"; 
	public final String VALID_INCIDENT = "VALID_INCIDENT"; 

	
	// Retrieve Customer Product Configuration
	//
	public final String DO_CUSTOMER_PRODUCT_CONFIG_ELEMENT = "customerConfiguration"; 
	
	public final String ATTR_CUSTOMER_NAME_IN_LOOKUP_REQUEST = "sourceCriteria[1]/Name";
	public final String ATTR_PRODUCT_USED_BY_CUSTOMER = "Product[1]/PhysicalResource[1]/Specification/Type"; 
	
	public final String PRODUCTS_USED_BY_CUSTOMER_PROPERTIES_FILE = "/ProductsUsedByCustomer.properties"; 
}
