--<ScriptOptions statementTerminator=";"/>

CREATE TABLE TELECOM_DOF.Category (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(64) NOT NULL,
		Description VARCHAR(128) NOT NULL
	);

CREATE TABLE TELECOM_DOF.Resource (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(32) NOT NULL,
		Type VARCHAR(32) NOT NULL,
		ResourceType VARCHAR(32) NOT NULL,
		ServiceId INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductResources (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ResourceID INTEGER NOT NULL,
		ProductID INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.Product (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(65) NOT NULL,
		Price VARCHAR(8) NOT NULL,
		Pricing_Model VARCHAR(16) NOT NULL,
		Availability VARCHAR(16) NOT NULL,
		Category_Id INTEGER NOT NULL,
		Description VARCHAR(128) NOT NULL
	);

CREATE TABLE TELECOM_DOF.ProductServices (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		ServiceId INTEGER NOT NULL,
		ProductId INTEGER NOT NULL
	);

CREATE TABLE TELECOM_DOF.Service (
		Id INTEGER  NOT NULL GENERATED ALWAYS AS IDENTITY  (START WITH 1 ,INCREMENT BY 1),
		Name VARCHAR(32) NOT NULL,
		Type VARCHAR(8) NOT NULL,
		ServiceType VARCHAR(32) NOT NULL
	);

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Resources1 PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Resource ADD CONSTRAINT Resource_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Product ADD CONSTRAINT Product_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Service ADD CONSTRAINT Service_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.Category ADD CONSTRAINT Category_PK PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Services_1 PRIMARY KEY (Id);

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Se_Serv_FK FOREIGN KEY (ServiceId)
	REFERENCES TELECOM_DOF.Service (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Re_Prod_FK FOREIGN KEY (ProductID)
	REFERENCES TELECOM_DOF.Product (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.Product ADD CONSTRAINT Produc_Categor_FK FOREIGN KEY (Category_Id)
	REFERENCES TELECOM_DOF.Category (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ProductResources ADD CONSTRAINT Product_Re_Reso_FK FOREIGN KEY (ResourceID)
	REFERENCES TELECOM_DOF.Resource (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.Resource ADD CONSTRAINT Resourc_Servic_FK FOREIGN KEY (ServiceId)
	REFERENCES TELECOM_DOF.Service (Id)
	ON DELETE RESTRICT;

ALTER TABLE TELECOM_DOF.ProductServices ADD CONSTRAINT Product_Se_Prod_FK FOREIGN KEY (ProductId)
	REFERENCES TELECOM_DOF.Product (Id)
	ON DELETE RESTRICT;

