/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.NamedQuery;
import javax.persistence.NamedQueries;
import javax.persistence.OneToMany;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
@NamedQueries( {
				@NamedQuery(name = "getCategoryById", query = "SELECT category FROM Category category where category.id =:id"),
				@NamedQuery(name = "getAllCategories", query = "SELECT category FROM Category category")
	})
public class Category extends TelecomBaseObject implements Serializable {

	private String name;

	private String description;

	@OneToMany(mappedBy = "category")
	private Set<Product> productCollection;

	private static final long serialVersionUID = 1L;

	public Category() {
		super();
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return this.description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Set<Product> getProductCollection() {
		return this.productCollection;
	}

	public void setProductCollection(Set<Product> productCollection) {
		this.productCollection = productCollection;
	}

}
