/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
public class Resource extends TelecomBaseObject implements Serializable {

	private String name;

	private String type;

	private String resourcetype;

	@ManyToOne
	@JoinColumn(name = "SERVICEID")
	private Service serviceid;

	@OneToMany(mappedBy = "resourceid")
	private Set<Productresources> productresourcesCollection;

	private static final long serialVersionUID = 1L;

	public Resource() {
		super();
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getType() {
		return this.type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getResourcetype() {
		return this.resourcetype;
	}

	public void setResourcetype(String resourcetype) {
		this.resourcetype = resourcetype;
	}

	public Service getServiceid() {
		return this.serviceid;
	}

	public void setServiceid(Service serviceid) {
		this.serviceid = serviceid;
	}

	public Set<Productresources> getProductresourcesCollection() {
		return this.productresourcesCollection;
	}

	public void setProductresourcesCollection(
			Set<Productresources> productresourcesCollection) {
		this.productresourcesCollection = productresourcesCollection;
	}

}
