/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.OneToMany;

import com.ibm.websphere.icp.telecom.db.entities.TelecomBaseObject;

@Entity
public class Service extends TelecomBaseObject implements Serializable {

	private String name;

	private String type;

	private String servicetype;

	@OneToMany(mappedBy = "serviceid")
	private Set<Productservices> productservicesCollection;

	@OneToMany(mappedBy = "serviceid")
	private Set<Resource> resourceCollection;

	private static final long serialVersionUID = 1L;

	public Service() {
		super();
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getType() {
		return this.type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getServicetype() {
		return this.servicetype;
	}

	public void setServicetype(String servicetype) {
		this.servicetype = servicetype;
	}

	public Set<Productservices> getProductservicesCollection() {
		return this.productservicesCollection;
	}

	public void setProductservicesCollection(
			Set<Productservices> productservicesCollection) {
		this.productservicesCollection = productservicesCollection;
	}

	public Set<Resource> getResourceCollection() {
		return this.resourceCollection;
	}

	public void setResourceCollection(Set<Resource> resourceCollection) {
		this.resourceCollection = resourceCollection;
	}

}
