/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.mock;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBFactoryConstants;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBManager;
import com.ibm.websphere.icp.industry.db.manager.WicpDBFactory;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Customermaster;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Serviceorder;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.util.IConstants;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class QueryBillingAccountImpl {
	/**
	 * Default constructor.
	 */
	public QueryBillingAccountImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation
	 * "queryBillingAccount" defined for WSDL port type named
	 * "QueryBillingAccountPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 */
	public DataObject queryBillingAccount(DataObject aCustomerAccountMessage) {

		DataObject customerAccountDO = aCustomerAccountMessage
				.getDataObject("customerAccount");

		int orderId = Integer.valueOf(customerAccountDO.getString("Id"));
		/**
		 * Create the Map to fetch Customer from Db
		 */
		Map<String, Object> mapParams = new HashMap<String, Object>();
		mapParams.put("id", orderId);

		/**
		 * get the DbFactory and persist data
		 */
		Properties dbProperties = new Properties();
		dbProperties.setProperty(IWicpDBFactoryConstants.TYPE, "JPA");
		dbProperties.setProperty(IWicpDBFactoryConstants.PERSISTENCE_UNIT_NAME,
				IConstants.DB_ACCESS);
		IWicpDBManager wicpDbManager = WicpDBFactory.getDBManager(dbProperties);

		Customermaster customerMaster = new Customermaster();
		Serviceorder serviceorder = new Serviceorder();
		List result = wicpDbManager.executeNamedQuery("findCustomerByOrderId",
				mapParams);
		DataObject rsCustomerAccountMessage = IndustrySupportUtil
				.createDO(
						"http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/billing/schema/CustomerConfigurationMessage",
						"CustomerAccountMessage");
		DataObject rsCustomerAccount = rsCustomerAccountMessage
				.createDataObject("customerAccount");

		if (result.size() > 0) {
			serviceorder = (Serviceorder) wicpDbManager.executeNamedQuery(
					"findCustomerByOrderId", mapParams).get(0);
			customerMaster = serviceorder.getCustomerMaster();
			DataObject rsContactPerson = rsCustomerAccount
					.createDataObject("ContactPerson");
			rsContactPerson.setString("Id", String.valueOf(customerMaster
					.getId()));

			DataObject rsSpecification = rsContactPerson
					.createDataObject("Specification");
			rsSpecification.setString("Id", String.valueOf(customerMaster
					.getAccount().getId()));

			DataObject rsParty = rsContactPerson.createDataObject("Party");
			List rsCharacteristicValueList = new ArrayList();

			DataObject characteristicValueTitle = putValueInCharacterList(
					"Title", customerMaster.getTitle());
			DataObject characteristicValueFirstName = putValueInCharacterList(
					"FirstName", customerMaster.getFirstName());
			DataObject characteristicValueMiddleName = putValueInCharacterList(
					"MiddleName", customerMaster.getMiddleName());
			DataObject characteristicValueLastName = putValueInCharacterList(
					"LastName", customerMaster.getLastName());

			DataObject characteristicValueStreetNumber = putValueInCharacterList(
					"StreetNumber", customerMaster.getStreetNr());
			DataObject characteristicValueStreetName = putValueInCharacterList(
					"StreetName", customerMaster.getStreetName());
			DataObject characteristicValueStreetType = putValueInCharacterList(
					"Locality", customerMaster.getStreetType());
			DataObject characteristicValueUnitName = putValueInCharacterList(
					"AppartmentName", String
							.valueOf(customerMaster.getUnitNr()));
			DataObject characteristicValueUnit = putValueInCharacterList(
					"AppartmentUnit", customerMaster.getUnitType());
			DataObject characteristicValueCITY = putValueInCharacterList(
					"City", customerMaster.getCity());
			DataObject characteristicValueState = putValueInCharacterList(
					"State", customerMaster.getState());
			DataObject characteristicValueCountry = putValueInCharacterList(
					"Country", customerMaster.getCountry());
			DataObject characteristicValueZipcode = putValueInCharacterList(
					"Zipcode", customerMaster.getPostCode());
			DataObject characteristicValuePreferedLanguage = putValueInCharacterList(
					"PreferredLanguage", customerMaster.getPreferredLangauge());

			rsCharacteristicValueList.add(characteristicValueTitle);
			rsCharacteristicValueList.add(characteristicValueFirstName);
			rsCharacteristicValueList.add(characteristicValueMiddleName);
			rsCharacteristicValueList.add(characteristicValueLastName);
			rsCharacteristicValueList.add(characteristicValueStreetNumber);
			rsCharacteristicValueList.add(characteristicValueStreetName);
			rsCharacteristicValueList.add(characteristicValueStreetType);
			rsCharacteristicValueList.add(characteristicValueUnit);
			rsCharacteristicValueList.add(characteristicValueUnitName);
			rsCharacteristicValueList.add(characteristicValueCITY);
			rsCharacteristicValueList.add(characteristicValueState);
			rsCharacteristicValueList.add(characteristicValueCountry);
			rsCharacteristicValueList.add(characteristicValueZipcode);
			rsCharacteristicValueList.add(characteristicValuePreferedLanguage);

			rsParty.setList("CharacteristicValue", rsCharacteristicValueList);

			DataObject rsContactMedium = rsParty
					.createDataObject("ContactMedium");

			List rsAdditionalCharacteristicValueList = new ArrayList();

			DataObject characteristicValueMobileNumber = putValueInCharacterList(
					"MobileNumber", customerMaster.getMobilePhoneNumber());
			DataObject characteristicValuePhoneNumber = putValueInCharacterList(
					"PhoneNumber", customerMaster.getFixedLinePhoneNumber());

			DataObject characteristicValueEmail = putValueInCharacterList(
					"Email", customerMaster.getEmail());

			rsAdditionalCharacteristicValueList
					.add(characteristicValueMobileNumber);
			rsAdditionalCharacteristicValueList
					.add(characteristicValuePhoneNumber);
			rsAdditionalCharacteristicValueList.add(characteristicValueEmail);

			rsContactMedium.setList("CharacteristicValue",
					rsAdditionalCharacteristicValueList);
			List rsContactMediumList = new ArrayList();
			rsContactMediumList.add(rsContactMedium);
			rsParty.setList("ContactMedium", rsContactMediumList);

			rsCustomerAccount.setString("AccountStatus", "Existing");
		} else {
			rsCustomerAccount.setString("AccountStatus", "New");
		}

		return rsCustomerAccountMessage;
	}

	private DataObject putValueInCharacterList(String feildName, String Value) {

		DataObject characteristicValue = IndustrySupportUtil.createDO(
				"http://www.ibm.com/telecom/common/schema/base/v3_0",
				"CharacteristicValue");
		DataObject characteristic = characteristicValue
				.createDataObject("Characteristic");
		characteristic.setString("Name", feildName);
		List valuestr = new ArrayList();
		valuestr.add(Value);
		characteristicValue.set("Value", valuestr);
		return characteristicValue;

	}

}
