/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 * 
 * (C) Copyright IBM Corp. 2010 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.mock;

import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import com.ibm.websphere.fabric.industry.support.util.IndustrySupportUtil;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBFactoryConstants;
import com.ibm.websphere.icp.industry.db.manager.IWicpDBManager;
import com.ibm.websphere.icp.industry.db.manager.WicpDBFactory;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Category;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.Product;
import com.ibm.websphere.icp.telecom.reference.dynamicorderfulfillment.util.IConstants;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class QueryProductImpl {
	/**
	 * Default constructor.
	 */
	public QueryProductImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implementation of operation
	 * "findProductOrder" defined for WSDL port type named "FindProductOrderPT".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a
	 * parameter type conveys that it is a complex type. Please refer to the
	 * WSDL Definition for more information on the type of input, output and
	 * fault(s).
	 */
	public DataObject findProductOrder(DataObject aProductOrderMessage) {
		// Category category1 = new Category();
		// category1.setDescription("Wireless");
		// category1.setName("Wireless Products");
		//
		// Category category2 = new Category();
		// category2.setDescription("Wireless");
		// category2.setName("Mobile Products");
		//
		// Product product = new Product();
		// product.setCategory(category1);
		// product.setName("Access Line");
		// product.setDescription("AccessLine");
		// product.setAvailability("Available");
		// product.setPrice("800");
		// product.setPricingModel("Solo");
		//		 
		// Product product2 = new Product();
		// product2.setCategory(category1);
		// product2.setName("Directory Listing");
		// product2.setDescription("Directory Listing");
		// product2.setAvailability("Available");
		// product2.setPrice("800");
		// product2.setPricingModel("Solo");
		//
		// Product product3 = new Product();
		// product3.setCategory(category2);
		// product3.setName("Conferencing");
		// product3.setDescription("Conferencing");
		// product3.setAvailability("Available");
		// product3.setPrice("800");
		// product3.setPricingModel("Solo");
		//		 
		// Product product4 = new Product();
		// product4.setCategory(category2);
		// product4.setName("Enhanced Services");
		// product4.setDescription("Enhanced Services");
		// product4.setAvailability("Available");
		// product4.setPrice("800");
		// product4.setPricingModel("Solo");
		//		 
		//		 
		// Product product5 = new Product();
		// product5.setCategory(category2);
		// product5.setName("Healthcare Services");
		// product5.setDescription("Healthcare Services");
		// product5.setAvailability("Available");
		// product5.setPrice("800");
		// product5.setPricingModel("Solo");

		/**
		 * get the DbFactory and persist data
		 */
		Properties dbProperties = new Properties();
		dbProperties.setProperty(IWicpDBFactoryConstants.TYPE, "JPA");
		dbProperties.setProperty(IWicpDBFactoryConstants.PERSISTENCE_UNIT_NAME,
				IConstants.DB_ACCESS);

		IWicpDBManager wicpDbManager = WicpDBFactory.getDBManager(dbProperties);
		List productList = new ArrayList();
		List categoryList = new ArrayList();
		try {
			// wicpDbManager.save(category1);
			// wicpDbManager.save(category2);
			// wicpDbManager.save(product);
			// wicpDbManager.save(product2);
			// wicpDbManager.save(product3);
			// wicpDbManager.save(product4);
			// wicpDbManager.save(product5);
			categoryList = wicpDbManager.executeNamedQuery("getAllCategories",
					null);
			productList = wicpDbManager.executeNamedQuery("getAllProducts",
					null);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		/**
		 * From The productList Extract product and group them in Categories
		 */

		DataObject productOrderCollectionMessage = IndustrySupportUtil
				.createDO(
						"http://www.ibm.com/xmlns/prod/websphere/fabric/2009/12/telecom/operations/fulfillment/schema/ProductOrderMessage",
						"ProductOrderCollectionMessage");

		List productOrderList = new ArrayList();

		for (int i = 0; i < categoryList.size(); i++) {
			List productOrderItemList = new ArrayList();
			DataObject productOrder = IndustrySupportUtil
					.createDO(
							"http://www.ibm.com/telecom/fulfillment/schema/product_order/v3_0",
							"ProductOrder");
			Category category = (Category) categoryList.get(i);
			productOrder.setString("Id", String.valueOf(category.getId()));
			productOrder.setString("Name", category.getName());

			for (int j = 0; j < productList.size(); j++) {

				Product product = new Product();
				DataObject productOrderItem = IndustrySupportUtil
						.createDO(
								"http://www.ibm.com/telecom/fulfillment/schema/product_order/v3_0",
								"ProductOrderItem");
				DataObject productDO = productOrderItem
						.createDataObject("Product");

				product = (Product) productList.get(j);

				if (product.getCategory().getId() == category.getId()) {

					productDO.setString("Id", String.valueOf(product.getId()));
					productDO.setString("Name", product.getName());

					List characteristicValuelist = new ArrayList();
					DataObject characteristicValuePrice = putValueInCharacterList(
							"PRICE", product.getPrice());
					DataObject characteristicValuePriceModel = putValueInCharacterList(
							"PRICE_MODEL", product.getPricingModel());
					DataObject characteristicValueAvailability = putValueInCharacterList(
							"AVAILABILITY", product.getAvailability());
					DataObject characteristicValueDesc = putValueInCharacterList(
							"AVAILABILITY", product.getDescription());

					characteristicValuelist.add(characteristicValuePrice);
					characteristicValuelist.add(characteristicValuePriceModel);
					characteristicValuelist
							.add(characteristicValueAvailability);
					characteristicValuelist.add(characteristicValueDesc);

					productDO.setList("CharacteristicValue",
							characteristicValuelist);
					productOrderItemList.add(productOrderItem);
				}
			}
			productOrder.setList("ProductOrderItem", productOrderItemList);
			productOrderList.add(productOrder);
		}
		productOrderCollectionMessage.set("productOrder", productOrderList);
		return productOrderCollectionMessage;
	}

	private DataObject putValueInCharacterList(String feildName, String Value) {

		DataObject characteristicValue = IndustrySupportUtil.createDO(
				"http://www.ibm.com/telecom/common/schema/base/v3_0",
				"CharacteristicValue");
		DataObject characteristic = characteristicValue
				.createDataObject("Characteristic");
		characteristic.setString("Name", feildName);
		List valuestr = new ArrayList();
		valuestr.add(Value);
		characteristicValue.set("Value", valuestr);
		return characteristicValue;

	}
}
